OGRE: Ogre::Pose Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Pose Class Reference
Core » Animation

A pose is a linked set of vertex offsets applying to one set of vertex data. More...

`#include <OgrePose.h>`

Inheritance diagram for Ogre::Pose:
[legend]

## Public Types
typedef ConstMapIterator< NormalsMap > | ConstNormalsIterator
| An iterator over the vertex offsets.
typedef ConstMapIterator< VertexOffsetMap > | ConstVertexOffsetIterator
| An iterator over the vertex offsets.
typedef MapIterator< NormalsMap > | NormalsIterator
| An iterator over the vertex offsets.
typedef std::map< uint32, Vector3f > | NormalsMap
| A collection of normals based on the vertex index.
typedef MapIterator< VertexOffsetMap > | VertexOffsetIterator
| An iterator over the vertex offsets.
typedef std::map< uint32, Vector3f > | VertexOffsetMap
| A collection of vertex offsets based on the vertex index.

## Public Member Functions
| Pose (ushort target, const String &name=BLANKSTRING)
| Constructor.
const HardwareVertexBufferSharedPtr & | _getHardwareVertexBuffer (const VertexData *origData) const
| Get a hardware vertex buffer version of the vertex offsets.
NormalsMap & | _getNormals ()
| writable access to the vertex normals for offline processing
VertexOffsetMap & | _getVertexOffsets ()
| writable access to the vertex offsets for offline processing
void | addVertex (uint32 index, const Vector3f &offset)
| Adds an offset to a vertex for this pose.
void | addVertex (uint32 index, const Vector3f &offset, const Vector3f &normal)
| Adds an offset to a vertex and a new normal for this pose.
void | clearVertices (void)
| Clear all vertices.
Pose * | clone (void) const
| Clone this pose and create another one configured exactly the same way (only really useful for cloning holders of this class).
bool | getIncludesNormals () const
| Return whether the pose vertices include normals.
const String & | getName (void) const
| Return the name of the pose (may be blank).
const NormalsMap & | getNormals (void) const
| Gets a const reference to the vertex normals.
NormalsIterator | getNormalsIterator (void)
ConstNormalsIterator | getNormalsIterator (void) const
ushort | getTarget (void) const
| Return the target geometry index of the pose.
VertexOffsetIterator | getVertexOffsetIterator (void)
ConstVertexOffsetIterator | getVertexOffsetIterator (void) const
const VertexOffsetMap & | getVertexOffsets (void) const
| Gets a const reference to the vertex offsets.
void | removeVertex (uint32 index)
| Remove a vertex offset.

## Detailed Description

A pose is a linked set of vertex offsets applying to one set of vertex data.

The target index referred to by the pose has a meaning set by the user of this class; but for example when used by Mesh it refers to either the Mesh shared geometry (0) or a SubMesh dedicated geometry (1+). Pose instances can be referred to by keyframes in VertexAnimationTrack in order to animate based on blending poses together.

## Member Typedef Documentation

## ◆ VertexOffsetMap

typedef std::map<uint32, Vector3f> Ogre::Pose::VertexOffsetMap

A collection of vertex offsets based on the vertex index.

## ◆ VertexOffsetIterator

typedef MapIterator<VertexOffsetMap> Ogre::Pose::VertexOffsetIterator

An iterator over the vertex offsets.

## ◆ ConstVertexOffsetIterator

typedef ConstMapIterator<VertexOffsetMap> Ogre::Pose::ConstVertexOffsetIterator

An iterator over the vertex offsets.

## ◆ NormalsMap

typedef std::map<uint32, Vector3f> Ogre::Pose::NormalsMap

A collection of normals based on the vertex index.

## ◆ NormalsIterator

typedef MapIterator<NormalsMap> Ogre::Pose::NormalsIterator

An iterator over the vertex offsets.

## ◆ ConstNormalsIterator

typedef ConstMapIterator<NormalsMap> Ogre::Pose::ConstNormalsIterator

An iterator over the vertex offsets.

## Constructor & Destructor Documentation

## ◆ Pose()

Ogre::Pose::Pose | ( | ushort | target,
|  | const String & | name = BLANKSTRING )

Constructor.

Parameters

  target | The target vertexdata index (0 for shared, 1+ for dedicated at the submesh index + 1)
  name | Optional name

References Ogre::BLANKSTRING.

Referenced by clone().

## Member Function Documentation

## ◆ getName()

const String & Ogre::Pose::getName | ( | void |  | ) | const
| inline

Return the name of the pose (may be blank).

## ◆ getTarget()

ushort Ogre::Pose::getTarget | ( | void |  | ) | const
| inline

Return the target geometry index of the pose.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getIncludesNormals()

bool Ogre::Pose::getIncludesNormals | ( |  | ) | const
| inline

Return whether the pose vertices include normals.

## ◆ addVertex() [1/2]

void Ogre::Pose::addVertex | ( | uint32 | index,
|  | const Vector3f & | offset )

Adds an offset to a vertex for this pose.

Parameters

  index | The vertex index
  offset | The position offset for this pose

## ◆ addVertex() [2/2]

void Ogre::Pose::addVertex | ( | uint32 | index,
|  | const Vector3f & | offset,
|  | const Vector3f & | normal )

Adds an offset to a vertex and a new normal for this pose.

Parameters

  index | The vertex index
  offset | The position offset for this pose
  normal | The new vertex normal

## ◆ removeVertex()

void Ogre::Pose::removeVertex | ( | uint32 | index | ) |

Remove a vertex offset.

## ◆ clearVertices()

void Ogre::Pose::clearVertices | ( | void |  | ) |

Clear all vertices.

## ◆ getVertexOffsetIterator() [1/2]

ConstVertexOffsetIterator Ogre::Pose::getVertexOffsetIterator | ( | void |  | ) | const

Deprecated
  use getVertexOffsets

## ◆ getVertexOffsetIterator() [2/2]

VertexOffsetIterator Ogre::Pose::getVertexOffsetIterator | ( | void |  | ) |

Deprecated
  use getVertexOffsets

## ◆ getVertexOffsets()

const VertexOffsetMap & Ogre::Pose::getVertexOffsets | ( | void |  | ) | const
| inline

Gets a const reference to the vertex offsets.

## ◆ getNormalsIterator() [1/2]

ConstNormalsIterator Ogre::Pose::getNormalsIterator | ( | void |  | ) | const

Deprecated
  use getNormals

## ◆ getNormalsIterator() [2/2]

NormalsIterator Ogre::Pose::getNormalsIterator | ( | void |  | ) |

Deprecated
  use getNormals

## ◆ getNormals()

const NormalsMap & Ogre::Pose::getNormals | ( | void |  | ) | const
| inline

Gets a const reference to the vertex normals.

## ◆ _getVertexOffsets()

VertexOffsetMap & Ogre::Pose::_getVertexOffsets | ( |  | ) |
| inline

writable access to the vertex offsets for offline processing

Attention
  does not invalidate the vertexbuffer

## ◆ _getNormals()

NormalsMap & Ogre::Pose::_getNormals | ( |  | ) |
| inline

writable access to the vertex normals for offline processing

Attention
  does not invalidate the vertexbuffer

## ◆ _getHardwareVertexBuffer()

const HardwareVertexBufferSharedPtr & Ogre::Pose::_getHardwareVertexBuffer | ( | const VertexData * | origData | ) | const

Get a hardware vertex buffer version of the vertex offsets.

## ◆ clone()

Pose * Ogre::Pose::clone | ( | void |  | ) | const

Clone this pose and create another one configured exactly the same way (only really useful for cloning holders of this class).

References Pose(), and OGRE_NODISCARD.

The documentation for this class was generated from the following file:

- OgrePose.h